; Script generated by the HM NIS Edit Script Wizard.
; XXX: modules loaded as plugins create .pyc files
;      which aren't deleted automatically by the installer

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "ProxMon"
;!define PRODUCT_VERSION "1.0.10"
!define PRODUCT_PUBLISHER "iSEC Partners, Inc."
!define PRODUCT_WEB_SITE "http://www.isecpartners.com"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\proxmon.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

; Automatically get version
Function InitVersion
  !tempfile VERFILE
  !system 'echo !define PRODUCT_VERSION \ > "${VERFILE}"'
  !system 'make version | grep -v "make" >> "${VERFILE}"'
  !include ${VERFILE}
FunctionEnd

Function .onInit
  call InitVersion
FunctionEnd

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "LICENSE"
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "ProxMon"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\proxmon.pdf"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "proxmon-${PRODUCT_VERSION}.exe"
InstallDir "$PROGRAMFILES\ProxMon"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite try
  File "dist\bz2.pyd"
  File "dist\crypto.pyd"
  File "dist\libeay32.dll"
  File "dist\library.zip"
  SetOutPath "$INSTDIR\modules"
  File "dist\modules\bad_directories.cfg"
  File "dist\modules\bad_directories.py"
  File "dist\modules\bad_files.cfg"
  File "dist\modules\bad_files.py"
  File "dist\modules\comment_warn.cfg"
  File "dist\modules\comment_warn.py"
  File "dist\modules\cookie_sent_on_qs.py"
  File "dist\modules\cookie_summary.py"
  File "dist\modules\dir_listing.py"
  File "dist\modules\http_auth.py"
  File "dist\modules\id_framework_passive.cfg"
  File "dist\modules\id_framework_passive.py"
  File "dist\modules\js_warn.cfg"
  File "dist\modules\js_warn.py"
  File "dist\modules\offsite_redirect.py"
  File "dist\modules\query_summary.py"
  File "dist\modules\secure_cookies_sent_clear.py"
  File "dist\modules\ssl_config.py"
  File "dist\modules\ssl_val_sent_clear.py"
  File "dist\modules\value_sent_thirdparty.py"
  File "dist\modules\writable_dir.py"
  File "dist\modules\__init__.py"
  SetOutPath "$INSTDIR"
  File "dist\MSVCR71.dll"
  File "dist\pmcheck.py"
  File "dist\pmdata.py"
  File "dist\pmproxy.py"
  File "dist\pmutil.py"
  SetOutPath "$INSTDIR\proxies"
  File "dist\proxies\webscarab.py"
  File "dist\proxies\__init__.py"
  SetOutPath "$INSTDIR"
  File "dist\proxmon.exe"
  File "dist\proxmon.pdf"
  File "dist\proxmon.py"
  File "dist\pycurl.pyd"
  File "dist\python24.dll"
  File "dist\rand.pyd"
  File "dist\README"
  File "dist\LICENSE"
  File "dist\select.pyd"
  File "dist\setup.py"
  File "dist\SSL.pyd"
  File "dist\ssleay32.dll"
  File "dist\ChangeLog"
  File "dist\transaction.py"
  File "dist\unicodedata.pyd"
  File "dist\urltesting.py"
  File "dist\w9xpopen.exe"
  File "dist\zlib.pyd"
  File "dist\_socket.pyd"
  File "dist\_ssl.pyd"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\ProxMon.lnk" "$INSTDIR\proxmon.exe"
  CreateShortCut "$DESKTOP\ProxMon.lnk" "$INSTDIR\proxmon.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -AdditionalIcons
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\proxmon.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\proxmon.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\_ssl.pyd"
  Delete "$INSTDIR\_socket.pyd"
  Delete "$INSTDIR\zlib.pyd"
  Delete "$INSTDIR\w9xpopen.exe"
  Delete "$INSTDIR\urltesting.py"
  Delete "$INSTDIR\unicodedata.pyd"
  Delete "$INSTDIR\transaction.py"
  Delete "$INSTDIR\ChangeLog"
  Delete "$INSTDIR\ssleay32.dll"
  Delete "$INSTDIR\SSL.pyd"
  Delete "$INSTDIR\setup.py"
  Delete "$INSTDIR\select.pyd"
  Delete "$INSTDIR\README"
  Delete "$INSTDIR\LICENSE"
  Delete "$INSTDIR\rand.pyd"
  Delete "$INSTDIR\python24.dll"
  Delete "$INSTDIR\pycurl.pyd"
  Delete "$INSTDIR\proxmon.pdf"
  Delete "$INSTDIR\proxmon.py"
  Delete "$INSTDIR\proxmon.cj"
  Delete "$INSTDIR\proxmon.exe"
  Delete "$INSTDIR\proxies\__init__.py"
  Delete "$INSTDIR\proxies\__init__.pyc"
  Delete "$INSTDIR\proxies\webscarab.py"
  Delete "$INSTDIR\proxies\webscarab.pyc"
  Delete "$INSTDIR\pmutil.py"
  Delete "$INSTDIR\pmproxy.py"
  Delete "$INSTDIR\pmdata.py"
  Delete "$INSTDIR\pmcheck.py"
  Delete "$INSTDIR\MSVCR71.dll"
  Delete "$INSTDIR\modules\__init__.py"
  Delete "$INSTDIR\modules\writable_dir.py"
  Delete "$INSTDIR\modules\writable_dir.pyc"
  Delete "$INSTDIR\modules\value_sent_thirdparty.py"
  Delete "$INSTDIR\modules\value_sent_thirdparty.pyc"
  Delete "$INSTDIR\modules\ssl_val_sent_clear.py"
  Delete "$INSTDIR\modules\ssl_val_sent_clear.pyc"
  Delete "$INSTDIR\modules\ssl_config.py"
  Delete "$INSTDIR\modules\ssl_config.pyc"
  Delete "$INSTDIR\modules\secure_cookies_sent_clear.py"
  Delete "$INSTDIR\modules\secure_cookies_sent_clear.pyc"
  Delete "$INSTDIR\modules\query_summary.py"
  Delete "$INSTDIR\modules\query_summary.pyc"
  Delete "$INSTDIR\modules\offsite_redirect.py"
  Delete "$INSTDIR\modules\offsite_redirect.pyc"
  Delete "$INSTDIR\modules\js_warn.py"
  Delete "$INSTDIR\modules\js_warn.pyc"
  Delete "$INSTDIR\modules\js_warn.cfg"
  Delete "$INSTDIR\modules\id_framework_passive.py"
  Delete "$INSTDIR\modules\id_framework_passive.pyc"
  Delete "$INSTDIR\modules\id_framework_passive.cfg"
  Delete "$INSTDIR\modules\http_auth.py"
  Delete "$INSTDIR\modules\http_auth.pyc"
  Delete "$INSTDIR\modules\dir_listing.py"
  Delete "$INSTDIR\modules\dir_listing.pyc"
  Delete "$INSTDIR\modules\cookie_summary.py"
  Delete "$INSTDIR\modules\cookie_summary.pyc"
  Delete "$INSTDIR\modules\cookie_sent_on_qs.py"
  Delete "$INSTDIR\modules\cookie_sent_on_qs.pyc"
  Delete "$INSTDIR\modules\comment_warn.py"
  Delete "$INSTDIR\modules\comment_warn.pyc"
  Delete "$INSTDIR\modules\comment_warn.cfg"
  Delete "$INSTDIR\modules\bad_files.py"
  Delete "$INSTDIR\modules\bad_files.pyc"
  Delete "$INSTDIR\modules\bad_files.cfg"
  Delete "$INSTDIR\modules\bad_directories.py"
  Delete "$INSTDIR\modules\bad_directories.pyc"
  Delete "$INSTDIR\modules\bad_directories.cfg"
  Delete "$INSTDIR\library.zip"
  Delete "$INSTDIR\libeay32.dll"
  Delete "$INSTDIR\crypto.pyd"
  Delete "$INSTDIR\bz2.pyd"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$DESKTOP\ProxMon.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\ProxMon.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\proxies"
  RMDir "$INSTDIR\modules"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
